/* $Id: TCorsikaReader.cc,v 1.1.1.1 2005/08/09 11:21:28 rulrich Exp $   */

#include <crs/TLongitudinal.h>
using namespace crs;

#include <iostream>


TLongitudinal::TLongitudinal (const float *data) {
    
  fData = data;
}


void TLongitudinal::Dump () {

  std::cout << "long:> " 
	    << " X/(gcm^{-2}): " << GetSlantDepth ()
	    << " N_g " << GetNGammas ()
	    << " N_e- " << GetNElectrons ()
	    << " N_e+ " << GetNPositrons ()
	    << " N_mu- " << GetNMuons ()
	    << " N_mu+ " << GetNAntiMuons ()
	    << " N_h " << GetNHadrons ()
	    << " N_ch " << GetNCharged ()
	    << " N_nuc " << GetNNuclei ()
	    << " N_ckov " << GetNCerenkov ()
	    << std::endl;
}
