c----------------------------------------------------------------------
      subroutine IniCon(nin)
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incico'
      character*80 fn
      logical table
        
      ii=index(fnhi(1:nfnhi),".histo")-1
      fn=fnhi(1:ii)//".ico"
      inquire(file=fn,exist=table)

      if(icotabr.eq.1)then  !read from file
      
        if(.not.table)then
          write(ifmt,'(//10x,3a//)')'STOP: file '
     *             ,fn(1:ii+4),' not found !!!'
          stop
        endif
        write(ifmt,'(3a)')'read from ',fn(1:ii+4),' ...'
        open(97,file=fn,status='old')
        read(97,*) engyx
        read(97,*) laprojx,maprojx,latargx,matargx
        read(97,*) bmaximx
        read(97,*) icospecx,icoremnx,icostrgx
        read(97,*) nxicox,nyicox,nzicox
        read(97,*)xminicox,xmaxicox,yminicox,ymaxicox,zminicox,zmaxicox
        if(engyx.ne.engy)    stop'variables dont match (1)    '
        if(1000*laprojx+100*maprojx+10*latargx+matargx
     * .ne.1000*laproj+100*maproj+10*latarg+matarg)
     *                       stop'variables dont match (2)    '
        if(bmaximx.ne.bmaxim)stop'variables dont match (3)    '
        if(100*icospecx+10*icoremnx+icostrgx
     * .ne.100*icospec +10*icoremn +icostrg)
     *                       stop'variables dont match (4)    '
        if(100*nxicox+10*nyicox+nzicox.ne.100*nxico+10*nyico+nzico)
     *                       stop'variables dont match (5)    '
        if(100000*xminicox+10000*xmaxicox+1000*yminicox
     *      +100*ymaxicox+10*zminicox+zmaxicox  .ne.
     *     100000*xminico +10000*xmaxico+ 1000*yminico
     *      +100*ymaxico +10*zminico +zmaxico)
     *                       stop'variables dont match (6)    '

        read(97,*) IcoT,IcoC,IcoE,IcoV,IcoF
        close(97)

      elseif(icotabr.eq.0)then  ! calculate

        if(icotabm.eq.1.and.table)then
          write(ifmt,'(//10x,3a//)')'STOP: file '
     *             ,fn(1:ii+4),' already exists !!!'
          stop
        endif

 	if(nin.eq.1)then
          write(ifmt,'(2a)')'calculate inicon table ... '
          call IcoStr(1) 
	endif

        if(nin.gt.1.and.nin.le.iabs(ninicon).and.mod(nin,modsho).eq.0)
     &          write(ifmt,*)'update ',nin,' / ',iabs(ninicon)
     &                       ,'    bimevt :',bimevt
        call IcoStr(2) 

        if(nin.eq.iabs(ninicon))then
	  call IcoStr(3)          

          if(icotabm.eq.1)then  ! make table
            write(ifmt,'(2a)')'write inicon table into ',fn(1:ii+4)
            open(97,file=fn,status='new')
            write(97,*) engy
            write(97,*) laproj,maproj,latarg,matarg
            write(97,*) bmaxim
            write(97,*) icospec,icoremn,icostrg
            write(97,*) nxico,nyico,nzico
            write(97,*) xminico,xmaxico,yminico,ymaxico,zminico,zmaxico
            write(97,*) IcoT,IcoC,IcoE,IcoV,IcoF
            close(97)
          endif
 	endif

      else

	stop'IniCon: wrong choice'

      endif

      end

c----------------------------------------------------------------------
      subroutine xIniCon(word)
c----------------------------------------------------------------------

        include 'nexus.inc'
        include 'nexus.incico'
        common /Ico10/ntot,ish0,irs
        character word*80

      	kval=0
	ival=0
      	kmax=1
      	do k=2,80
      	if(word(k:k).eq.'#')kval=k+1
      	if(word(k:k).ne.' ')kmax=k
     	enddo
	if(kval.gt.0)then
	read(word(kval:kmax),*)ival
      	do k=kval-1,kmax
      	word(k:k)=' '
     	enddo
	endif

		if(word.eq.'energydensity-xy')then
        
	call RootCanvas('energy density;',nyico,yminico,ymaxico
     *                                   ,nxico,xminico,xmaxico)
        iz=nzico/2+1+ival
        do iy=1,nyico
          yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(yy,xx,IcoE(ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','y;','x;')

		elseif(word.eq.'energydensity-xeta')then
       
	call RootCanvas('energy density;',nzico,zminico,zmaxico
     *                                   ,nxico,xminico,xmaxico)
        iy=nyico/2+1+ival
        do iz=1,nzico
          zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(zz,xx,IcoE(ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','eta;','x;')

		elseif(word.eq.'xvelocity-xy')then
        
	call RootCanvas('x velocity;',nyico,yminico,ymaxico
     *                               ,nxico,xminico,xmaxico)
        iz=nzico/2+1+ival
        do iy=1,nyico
          yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(yy,xx,IcoV(1,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','y;','x;')

		elseif(word.eq.'xvelocity-xeta')then
        
	call RootCanvas('x velocity;',nzico,zminico,zmaxico
     *                               ,nxico,xminico,xmaxico)
        iy=nyico/2+1+ival
        do iz=1,nzico
          zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(zz,xx,IcoV(1,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','eta;','x;')

		elseif(word.eq.'rapidity-xy')then
        
	call RootCanvas('rapidity;',nyico,yminico,ymaxico
     *                               ,nxico,xminico,xmaxico)
        iz=nzico/2+1+ival
        zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
        do iy=1,nyico
          yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            vz=IcoV(3,ix,iy,iz)
            en=IcoE(ix,iy,iz)
            rap=0
            if(en.gt.0.)rap=0.5*alog((1+vz)/(1-vz))+zz
            call RootFill(yy,xx,rap)
          enddo
        enddo
	call RootDraw('surf1;','y;','x;')

		elseif(word.eq.'rapidity-xeta')then
        
	call RootCanvas('rapidity;',nzico,zminico,zmaxico
     *                               ,nxico,xminico,xmaxico)
        iy=nyico/2+1+ival
        do iz=1,nzico
          zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            vz=IcoV(3,ix,iy,iz)
            en=IcoE(ix,iy,iz)
            rap=0
            if(en.gt.0.)rap=0.5*alog((1+vz)/(1-vz))+zz
             call RootFill(zz,xx,rap)
          enddo
        enddo
	call RootDraw('surf1;','eta;','x;')

		elseif(word.eq.'udflavor-xy')then
        
	call RootCanvas('ud flavor;',nyico,yminico,ymaxico
     *                               ,nxico,xminico,xmaxico)
        iz=nzico/2+1+ival
        do iy=1,nyico
          yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(yy,xx,IcoF(1,ix,iy,iz)+IcoF(2,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','y;','x;')

		elseif(word.eq.'udflavor-xeta')then
        
	call RootCanvas('ud flavor;',nzico,zminico,zmaxico
     *                               ,nxico,xminico,xmaxico)
        iy=nyico/2+1+ival
        do iz=1,nzico
          zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(zz,xx,IcoF(1,ix,iy,iz)+IcoF(2,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','eta;','x;')

		elseif(word.eq.'uflavor-xy')then
        
	call RootCanvas('u flavor;',nyico,yminico,ymaxico
     *                               ,nxico,xminico,xmaxico)
        iz=nzico/2+1+ival
        do iy=1,nyico
          yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(yy,xx,IcoF(1,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','y;','x;')

		elseif(word.eq.'uflavor-xeta')then
        
	call RootCanvas('u flavor;',nzico,zminico,zmaxico
     *                               ,nxico,xminico,xmaxico)
        iy=nyico/2+1+ival
        do iz=1,nzico
          zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(zz,xx,IcoF(1,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','eta;','x;')

		elseif(word.eq.'dflavor-xy')then
        
	call RootCanvas('d flavor;',nyico,yminico,ymaxico
     *                               ,nxico,xminico,xmaxico)
        iz=nzico/2+1+ival
        do iy=1,nyico
          yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(yy,xx,IcoF(2,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','y;','x;')

		elseif(word.eq.'dflavor-xeta')then
        
	call RootCanvas('d flavor;',nzico,zminico,zmaxico
     *                               ,nxico,xminico,xmaxico)
        iy=nyico/2+1+ival
        do iz=1,nzico
          zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(zz,xx,IcoF(2,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','eta;','x;')

		elseif(word.eq.'sflavor-xy')then
        
	call RootCanvas('s flavor;',nyico,yminico,ymaxico
     *                               ,nxico,xminico,xmaxico)
        iz=nzico/2+1+ival
        do iy=1,nyico
          yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(yy,xx,IcoF(3,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','y;','x;')

		elseif(word.eq.'sflavor-xeta')then
        
	call RootCanvas('s flavor;',nzico,zminico,zmaxico
     *                               ,nxico,xminico,xmaxico)
        iy=nyico/2+1+ival
        do iz=1,nzico
          zz=zminico+(float(iz)-0.5)*(zmaxico-zminico)/nzico
          do ix=1,nxico
            xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
            call RootFill(zz,xx,IcoF(3,ix,iy,iz))
          enddo
        enddo
	call RootDraw('surf1;','eta;','x;')

		endif
        
      end

c----------------------------------------------------------------------
      subroutine RootOpen()
c----------------------------------------------------------------------

      include 'nexus.inc'
      character xx*5
      common /canvas/icanvas,xx

      icanvas=0

      ii=index(fnhi(1:nfnhi),".histo")-1
      open(98,file=fnhi(1:ii)//".cc")
 
      write(98,'(a)')'{'
      write(98,'(a)')'gROOT->Reset();'
      write(98,'(a)')'gStyle->SetPalette(1);'
      write(98,'(a)')'gStyle->SetCanvasColor(33);'
      write(98,'(a)')'gStyle->SetFrameFillColor(18);  //18=white'
      write(98,'(a)')'TH2F * xx;'
      write(98,'(a)')'Float_t x,y,t,s;'
      write(98,*)

      end

c----------------------------------------------------------------------
      subroutine RootCanvas(text,nx,xmin,xmax,ny,ymin,ymax)
c----------------------------------------------------------------------

      include 'nexus.inc'
      character text*80, cc*5, xx*5
      common /canvas/icanvas,xx

      icanvas=icanvas+1
      write(cc,'(i5)')icanvas
      write(xx,'(i5)')icanvas
      n=4-icanvas/10
      cc(1:1)='c'
      xx(1:1)='x'
      do m=2,n
      cc(m:m)='0'
      xx(m:m)='0'
      enddo
       
      kmax=1
      do while(text(kmax:kmax).ne.';')
      kmax=kmax+1
      enddo
      kmax=kmax-1

      write(98,'(2a)')'TCanvas *'//cc//' = new TCanvas("'//cc
     *                   ,'", "'//cc//'",1);'

      write(98,'(3a,2(i5,a,e11.3,a,e11.3,a))')
     *         xx//' = new TH2F("'//xx//'","',text(1:kmax),'",'
     *          ,nx,',',xmin,',',xmax,',',ny,',',ymin,',',ymax,');'

      end

c----------------------------------------------------------------------
      subroutine RootFill(x,y,z)
c----------------------------------------------------------------------

      character xx*5
      common /canvas/icanvas,xx

      write(98,'(a,3(e11.3,a))')xx//'->Fill(',x,',',y,',',z,');'
      end

c----------------------------------------------------------------------
      subroutine RootDraw(style,textx,texty)
c----------------------------------------------------------------------
c draw styles:  lego1...4 surf1...4 contz colz contz&colz
c----------------------------------------------------------------------

      character style*80,textx*80,texty*80
      character xx*5
      common /canvas/icanvas,xx

      lmax=1
      do while(style(lmax:lmax).ne.';')
      lmax=lmax+1
      enddo
      lmax=lmax-1

      kx=1
      do while(textx(kx:kx).ne.';')
      kx=kx+1
      enddo
      kx=kx-1

      ky=1
      do while(texty(ky:ky).ne.';')
      ky=ky+1
      enddo
      ky=ky-1

      write(98,'(a)') xx//'->SetStats(0);'
      write(98,'(3a)')xx//'->Draw("',style(1:lmax),'");' 
      write(98,'(a)') xx//'->SetMarkerStyle(20) ; '
      write(98,'(a)') xx//'->SetMarkerColor(2) ; '
      write(98,'(a)') xx//'->SetMarkerSize(0.4) ; '
      write(98,'(a)') xx//'->GetXaxis()->SetTitleOffset(1.5);'
      write(98,'(3a)')xx//'->SetXTitle("',textx(1:kx),'");'
      write(98,'(a)') xx//'->GetYaxis()->SetTitleOffset(1.5);'
      write(98,'(3a)')xx//'->SetYTitle("',texty(1:ky),'");'
      write(98,*)
      end

c----------------------------------------------------------------------
      subroutine RootClose()
c----------------------------------------------------------------------

      write(98,'(a)')'}'
      close (98)
      end

c----------------------------------------------------------------------
      subroutine IcoStr(iflag)
c----------------------------------------------------------------------
c     energy momentum tensor and flavor current 
c     and corresponding contractions from string method
c
c     iflag = 1 initialization   
c           = 2 sum up density
c           = 3 normalization     
c     
c     output: common blocks /Ico1/ - /Ico5/ 
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incico'
      double precision tpro,zpro,ttar,ztar,ttaus,detap,detat
      common/cttaus/tpro,zpro,ttar,ztar,ttaus,detap,detat 
      dimension un(4,nxico,nyico,nzico)
      common /Ico10/ntot,ish0,irs
      dimension x(4),xa(4),xo(4),gam(4),gap(4)
     $     ,gp(4),gm(4),uu(4),pp(5),ps(4),pcum(5),pcum2(5),pcheck(5)
      dimension b(5),pf(5),unorm2(3)
      
c.....controll output......
      ish0=0                ! set to zero if you don't want the output
c...........................
      GOTO (1,10,100),iflag
      return

c......................................................................
c                             initialization      
c......................................................................

 1    do ix=1,nxico
        do iy=1,nyico
          do iz=1,nzico
            do i1=1,4
              do i2=1,3
                IcoC(i2,i1,ix,iy,iz)=0.
              enddo
              do i2=1,4
                IcoT(i1,i2,ix,iy,iz)=0.
              enddo
            enddo
          enddo
        enddo
      enddo
      ntot=0
      return

c......................................................................
c                        fill arrays      
c......................................................................

 10   ntot=ntot+1
      taum=1.0                  ! calculate intersection at tau=1 fm/c
                                ! here s and t are just the sigma,tau
                                ! of the kinky-string model. 
                                ! call them s,t to avoid confusion 
                                ! with the ivariant tau
      sigma=0.5                 ! width of gaussian smoothing kernel
      rnorm=(2.*pi)**(1.5)*sigma**3 ! its normalization


      ttaus=taum
      zz=0.
      istrs=icostrg   
      iremn=icoremn   
      ispec=icospec  
      nkmax=0
      nsmax=0
      do i=1,nptl               ! counting strings
      if((istptl(i).eq.20.or.istptl(i).eq.21)
     &        .and.ityptl(i).ge.20.and.ityptl(i).le.39)nsmax=i
        if(istptl(i).eq.20.or.istptl(i).eq.21)nkmax=i
c        if(istptl(i).eq.31)npmax=i
        if(ispec.ge.1.and.istptl(i).eq.0.and.i.le.maproj+matarg)then
          call idflav(idptl(i),ifl1,ifl2,ifl3,idummy,idummy)
          xorptl(3,i)=0.0
          xorptl(4,i)=0.0
          call jtain(i,xo(1),xo(2),xo(3),xo(4),nn,1)
          irs=i
          do iii=1,4
            ps(iii)=pptl(iii,i)
          enddo
          call IcoAddptl(ps,xo,taum,ifl1,ifl2,ifl3)
          if(ish0.ge.5)then
            write(ifmt,*)'Spectator'
            write(ifmt,223) i,idptl(i),(pptl(k,i),k=1,5)
     $             ,(xorptl(k,i),k=1,4)
     $             ,sqrt(pptl(3,i)**2
     $             +pptl(2,i)**2+pptl(1,i)**2)
          endif
        endif
        if(iremn.ge.1.and.istptl(i).le.11)then 
          if(iorptl(i).ge.1.and.istptl(iorptl(i)).eq.41)then
            if(idptl(i).gt.10**8)then
              call idqufl(i,idptl(i),nqu,nqd,nqs)
              call jtain(i,xo(1),xo(2),xo(3),xo(4),nn,1)
              irs=i
              do iii=1,4
                ps(iii)=pptl(iii,i)
              enddo
              call IcoAdddro(ps,xo,taum,nqu,nqd,nqs)
              if(ish0.ge.3)then
                write(ifmt,*)'Remnant (droplet)'
                write(ifmt,223) i,idptl(i),(pptl(k,i),k=1,5)
     $             ,(xorptl(k,i),k=1,4)
     $             ,sqrt(pptl(3,i)**2
     $             +pptl(2,i)**2+pptl(1,i)**2)
              endif
           else
              call idflav(idptl(i),ifl1,ifl2,ifl3,idummy,idummy)
              call jtain(i,xo(1),xo(2),xo(3),xo(4),nn,1)
              irs=i
              do iii=1,4
                ps(iii)=pptl(iii,i)
              enddo
              call IcoAddptl(ps,xo,taum,ifl1,ifl2,ifl3)
              if(ish0.ge.3)then
                write(ifmt,*)'Remnant (resonance)'
                write(ifmt,223) i,idptl(i),(pptl(k,i),k=1,5)
     $             ,(xorptl(k,i),k=1,4)
     $             ,sqrt(pptl(3,i)**2
     $             +pptl(2,i)**2+pptl(1,i)**2)
              endif
            endif
          endif
        endif
      enddo
      irs=0
      do iii=1,4
        ps(iii)=0.
      enddo

      if(istrs.eq.0.and.iremn.eq.0)return   !strings from remnant

      nk1=1
      if(istrs.eq.0)nk1=nsmax+1
      if(iremn.eq.0)nkmax=nsmax

      if(nkmax.eq.0)return          !no string

      do while(nk1.le.nkmax)
        if(istptl(nk1).eq.20.or.istptl(nk1).eq.21)then
          nk2=nk1+1
          do while(idptl(nk2).eq.9)
            nk2=nk2+1
          enddo
          n8=nk1              ! ok, string from nk1 to nk2 in pptl-list
          etot=0.               ! get total energy of string
          do i=nk1,nk2
            etot=etot+pptl(4,i)
            do iii=1,4
            enddo
          enddo
          if(ish0.ge.3)then 
            do i=nk1,nk2
 223          format(i5,1x,i10,1x,19(1pg14.7,1x))
              write(ifmt,223) i,idptl(i),(pptl(k,i),k=1,5)
     $             ,(xorptl(k,i),k=1,4)
     $             ,sqrt(pptl(3,i)**2
     $             +pptl(2,i)**2+pptl(1,i)**2)
            enddo
          endif
          dss=0.1           ! initial step-with in s (the string sigma)
          dslim=1e-4            ! lower bound for step-width
          am=0.05               ! HERE IS THE MASS OF THE STRING ENDS 
          dam=0.00001           ! wanted precision for string-end mass
          ds=dss  
          etamin= 1000.
          etamax=-1000.
c          ni=int((etot-2.0*ds/2.0)/ds)+1
          ip1=0
          ip2=0
          etaold=-1e10
c          esum=0.
          do ii=1,5
            pcum(ii)=0.
            pcheck(ii)=0.
          enddo
          s=0.0
          ifirst=0              ! have string beginning
          ilast=0               ! have string end
          imiddle=0             !
          ibound=0
c         do s = ds/2.,etot-ds/2.0,ds !   longitudinatl loop
          do while(s.lt.etot+dss/2.0.and.s.ge.-dss/2.0)
 200        ip1=int(pcheck(4)/etot*10.0)
            do while(ip2.lt.ip1)
              ip2=ip2+1
              if(ish0.ge.1)write (*,'(".",$)') 
            enddo
c            distm=1e10
            dist=0.
            t=taum              ! t is tau in the string picture
            dt=1.0              ! and not the invariant tau !!!
c           here we calculate the intersection of the string with the 
c           tau-line with precision 1e-7
            do while (abs(dt/t).gt.1e-7.and.t.lt.2.0*etot)
c get coordinates for s,t
              call xstr(nk1,nk2,s,t,x,gp,gm,ixy) 
              dist=0.
              dist=sqrt(max(0.,(x(4)+xorptl(4,n8))**2
     $             -(x(3)+xorptl(3,n8))**2))
c                distm= abs(dist-taum)
                do k=1,4
                  xa(k)=x(k)
                  gap(k)=gp(k)
                  gam(k)=gm(k)
                enddo
              if(dist.gt.taum)then
                t=t-dt
                dt=dt/2
              endif
              t=t+dt
            enddo
            if(s.le.ds/2.0) goto 53
            if(s.ge.etot+ds/2) goto 53
            do k=1,4
              xo(k)=xa(k)+xorptl(k,n8)
              ps(k)=sign(1.0,ds)*(gap(k)*(s-sold)+gam(k)*(t-told)) 
              pcum2(k)=pcum(k)+ps(k)
            enddo
            ps5=ps(4)**2-ps(3)**2-ps(2)**2-ps(1)**2
            if(ps5.le.0)then
              f=ps(4)/sqrt(ps(3)**2+ps(2)**2+ps(1)**2)
              do k=1,3
                ps(k)=f*ps(k)
              enddo
            endif
            do k=1,4
              pcum2(k)=pcum(k)+ps(k)
            enddo
            p2=pcum2(4)**2-pcum2(3)**2-pcum2(2)**2-pcum2(1)**2
            pcum2(5)=sign(sqrt(abs(p2)),p2)
c            if(s.gt.19)print *,"tauende:",ps
            ifl1=0
            ifl2=0
c...........crossing over region boundary .......................
            if(ixy.ne.ixyold.and.abs(ds).gt.1e-3)then
              ds=ds/2.0
              s=s-ds
              goto 200  
            elseif(ixy.ne.ixyold.and.abs(ds).lt.1e-3)then
              ibound=1
            endif
c...........string beginning.....................................
            ifinish=0
            if(imiddle.eq.0.and.ifirst.eq.0)then
              if(pcum2(5).gt.am.and.(pcum2(5).lt.am+dam
     $             .or.abs(ds).lt.dslim))then
 222            format(a12,14(1x,1pg14.6))
                if(ish0.ge.8)write (*,222) "adding af:",ps
                ifirst=1
                do k=1,5
                  pcum(k)=0.
                enddo
                ds=dss
                if(ish0.ge.8)then
                  eta= 0.5d0*log((xo(4)+xo(3))/(xo(4)-xo(3)))
                  rap= 0.5*log((pcum2(4)+pcum2(3))/(pcum2(4)-pcum2(3)))
                  write (*,222) "pcum2:", pcum2,rap
                  write (*,222) 'xo:  :',xo,eta
                endif
                ifinish=1
                ifl1=idptl(nk1)
                if(abs(ifl1).gt.1000)then
                  ifl1=sign(mod(abs(idptl(nk1))/1000,10),idptl(nk1))
                  ifl2=sign(mod(abs(idptl(nk1))/100,10),idptl(nk1))
                else
                  ifl2=0
                endif
              elseif(pcum2(5).gt.am)then 
                ds=ds/2.0
                s=s-ds
                goto 200
              else
                if(ish0.ge.8)write (*,222) "adding a :",ps
                do k=1,5
                  pcum(k)=pcum2(k)
                enddo
                if(ish0.ge.8)write (*,222) "cumm  :",pcum
                ifl1=idptl(nk1)
                if(abs(ifl1).gt.1000)then
                  ifl1=sign(mod(abs(idptl(nk1))/1000,10),idptl(nk1))
                  ifl2=sign(mod(abs(idptl(nk1))/100,10),idptl(nk1))
                else
                  ifl2=0
                endif
              endif
c...........string end
            elseif(imiddle.eq.1.and.ilast.eq.0)then
              if(pcum2(5).gt.am.and.(pcum2(5).lt.am+dam
     $             .or.abs(ds).lt.dslim))then
                if(ish0.ge.8)write (*,222) "adding ef:",ps
                ilast=1
                ds=-dss
                if(ish0.ge.8)then
                  eta= 0.5d0*log((xo(4)+xo(3))/(xo(4)-xo(3)))
                  rap= 0.5*log((pcum2(4)+pcum2(3))/(pcum2(4)-pcum2(3)))
                  write (*,222) "pcum2:",pcum2,rap 
                  write (*,222) "xo:  :",xo    ,eta
                endif
                ifl1=idptl(nk2)
                if(abs(ifl1).gt.1000)then
                  ifl1=sign(mod(abs(idptl(nk2))/1000,10),idptl(nk2))
                  ifl2=sign(mod(abs(idptl(nk2))/100,10),idptl(nk2))
                else
                  ifl2=0
                endif
                ifinish=1
              elseif(pcum2(5).gt.am)then 
                ds=ds/2.0
                s=s-ds
                goto 200
              else
                if(ish0.ge.8)write (*,222) "adding e :",ps
                do k=1,5
                  pcum(k)=pcum2(k)
                enddo
                if(ish0.ge.8)write (*,222) "cumm  :",pcum
                ifl1=idptl(nk2)
                if(abs(ifl1).gt.1000)then
                  ifl1=sign(mod(abs(idptl(nk2))/1000,10),idptl(nk2))
                  ifl2=sign(mod(abs(idptl(nk2))/100,10),idptl(nk2))
                else
                  ifl2=0
                endif
              endif
            elseif(imiddle.eq.0)then
              if(s.gt.etot/2.and.
     $             (s.lt.etot/2+0.0001.or.abs(ds).lt.dslim))then
                s=etot
                ds=-dss
                imiddle=1
                goto 200
              elseif(s.gt.etot/2)then
                ds=ds/2.0
                s=s-ds
                goto 200
              endif
            elseif(imiddle.eq.1)then
              if(s.lt.etot/2.and.
     $             (s.gt.etot/2-0.0001.or.abs(ds).lt.dslim))then
                imiddle=2
                s=etot*2.0
                goto 53
              elseif(s.lt.etot/2)then
                ds=ds/2.0
                s=s-ds
                goto 200
              endif
            endif
            do k=1,4
              pcheck(k)=pcheck(k)+ps(k)
            enddo
            if(ish0.ge.8)write (99,*) s,t,ixy,ds
            p2=pcheck(4)**2-pcheck(3)**2-pcheck(2)**2-pcheck(1)**2
            pcheck(5)=sign(sqrt(abs(p2)),p2)
            if(xo(3).ge.xo(4))then
              eta=1e10
            elseif(xo(3).le.-xo(4))then
              eta=-1e10
            else
              eta= 0.5d0*log((xo(4)+xo(3))/(xo(4)-xo(3)))
            endif
            if(eta.lt.etamin)etamin=eta
            if(eta.gt.etamax)etamax=eta
            deta=eta-etaold
            etaold=eta
            if(deta.gt.1e10)deta=0.
            if(ifl1.ne.0)then
              if(ish0.ge.8)write (*,'(2i4)') ixyold,ixy
              if(ish0.ge.8)write (*,'(a12,19(1x,f14.6))')
     $             "s,sold:",sold,s,told,t,eta,ps,pcum2(5)
cc              write (*,'(2i4,12(1x,g12.6))') ixyold,ixy,gap,gam,ds
            endif

c           string segment is calculated, 
c           now do the contribution to grid-points
            do iz=1,nzico
              zz=zminico +(float(iz)-0.5)*(zmaxico-zminico )/nzico
c.............boost ps() into co-moving frame with rapidity=zz
c             write (*,222) "p1:",eta,pp
              pp(1)=ps(1)
              pp(2)=ps(2)
              pp(3)=ps(3)
              pp(4)=ps(4)
              b(1)=0.
              b(2)=0.
              b(3)=sinh(-zz)
              b(4)=cosh(zz)
              b(5)=1.0
c             write (*,222) 'p2a:',pp     
              call utlobo(-1,b(1),b(2),b(3),b(4),b(5)
     $             ,pp(1),pp(2),pp(3),pp(4))
              if(ifl1.ne.0.and.ifinish.eq.1)then
                do kk=1,5
                  pf(kk)=pcum2(kk)
                enddo
                call utlobo(-1,b(1),b(2),b(3),b(4),b(5)
     $               ,pf(1),pf(2),pf(3),pf(4))
              endif
c             write (*,222) 'p2b:',pp
              do ix=1,nxico
                xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
                do iy=1,nyico
                  yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
                  d2=(xo(1)-xx)**2+(xo(2)-yy)**2
     $                 +( taum*( eta - zz ))**2
                  if(d2.gt.10.*sigma**2)then
                    w=0.
                  else
                    w=exp(-d2/2./sigma**2)/rnorm
c.....................energy-momentum Tensor 
                    if(ifl1.eq.0.or.(ifl1.ne.0.and.ifinish.eq.1))then
                      if(ifl1.ne.0.and.ifinish.eq.1)then
                        do k=1,4
                          pp(k)=pf(k)
                        enddo
                      endif
                      do i1=1,4
                        do i2=1,4
                            IcoT(i1,i2,ix,iy,iz)=IcoT(i1,i2,ix,iy,iz)+
     $                           w*pp(i1)*pp(i2)/pp(4)
                        enddo
                      enddo
                    endif
c.....................velocity field of particles
                    if(ifl1.ne.0.and.ifinish.eq.1)then
                      do i1=1,4
                        ifl=abs(ifl1)
                        f=1.0*sign(1.0,float(ifl1))
                        IcoC(ifl,i1,ix,iy,iz)=IcoC(ifl,i1,ix,iy,iz)+
     $                       f*w*pf(i1)/pf(4)
                        if(ifl2.ne.0)then
                          ifl=abs(ifl2)
                          f=1.0*sign(1.0,float(ifl2))
                          IcoC(ifl,i1,ix,iy,iz)=IcoC(ifl,i1,ix,iy,iz)+
     $                         f*w*pf(i1)/pf(4)
                        endif
                      enddo
                    endif
                  endif
                enddo
              enddo
            enddo
 53         told=t
           if(ibound.eq.1)then
              ds=sign(dss,ds)
              ibound=0
            endif
            sold=s
            s=s+ds
            ixyold=ixy
          enddo                 ! string ends
          if(ish0.ge.8) write (*,222) "final:",pcheck
          if(ish0.ge.1) write (*,'(4(i4,1x),10(g12.6,1x))')
     $         nk1,nk2,nkmax,ityptl(nk1),etot,etamin,etamax
          nk1=nk2+1
        else
          nk1=nk1+1
        endif
      enddo                     ! next string

      return
c......................................................................
c                 normalization and contraction of IcoT-tensor
c......................................................................

 100  ish2=0                    ! set to 1 if you want screen-output 

      do iy=1,nyico
        do ix=1,nxico
          do iz=1,nzico
            do i1=1,4
               do i2=1,4
           	 IcoT(i1,i2,ix,iy,iz)=IcoT(i1,i2,ix,iy,iz)/iabs(ninicon)
               enddo
               do ifl=1,3
               IcoC(ifl,i1,ix,iy,iz)=IcoC(ifl,i1,ix,iy,iz)/iabs(ninicon)
               enddo
             enddo
          enddo
        enddo
      enddo

      do iy=1,nyico
        yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
        do ix=1,nxico
          xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
          do iz=1,nzico
            zz=zminico +(float(iz)-0.5)*(zmaxico-zminico )/nzico
c           the flow is the one of energy-momentum 
            do i=1,4
              un(i,ix,iy,iz)=IcoT(i,4,ix,iy,iz)
            enddo
            unorm=sqrt(max(0.,un(4,ix,iy,iz)**2-un(3,ix,iy,iz)**2
     $           -un(2,ix,iy,iz)**2-un(1,ix,iy,iz)**2))
            if(unorm.gt.0.)then
              do i=1,4
                uu(i)=un(i,ix,iy,iz)/unorm
              enddo
            else

c              write(*,*)'ico : possible ?'
              do i=1,4
                uu(i)=0. 
              enddo
            endif
c
c           if IcoE(...)  we will have the energy-density
c           if IcoV(1..3,...) the flow-velocity

            IcoE(ix,iy,iz)=0.
            do i=1,3
              IcoV(i,ix,iy,iz)=0.
            enddo
            do ifl=1,3
              IcoF(ifl,ix,iy,iz)=0.
              unorm2(ifl)=sqrt(max(0.,IcoC(ifl,4,ix,iy,iz)**2
     $             -IcoC(ifl,3,ix,iy,iz)**2
     $             -IcoC(ifl,2,ix,iy,iz)**2
     $             -IcoC(ifl,1,ix,iy,iz)**2))
              if(unorm.ne.0.) then
                do i1=1,4
                  f1=1.0
                  if(i1.le.3) f1=-1.0 !  consider metric g_mu_nu
                  IcoF(ifl,ix,iy,iz)=IcoF(ifl,ix,iy,iz)
     $                 +f1*IcoC(ifl,i1,ix,iy,iz)*un(i1,ix,iy,iz)
     $                 /unorm
                enddo
              endif
            enddo
c...........
            if(uu(4).gt.0.)then
              if(ish2.ge.1)
     $             write (*,'(T1,"  energy-momentum Tensor at x=",f4.1
     $             ," y=",f4.1," eta=",f4.1
     $             ,T60,"current ",g12.6)') xx,yy,zz,unorm2(1)
              do i1=1,4
                do i2=1,4
                  f1=1.0
                  if(i1.le.3) f1=-1.0 !  consider metric g_mu_nu 
                  f2=1.0
                  if(i2.le.3) f2=-1.0 !  consider metric g_mu_nu 
                             ! for tau != 1 one has to multiply tau**2
                             !     in the third row because of 
                             !     hyperbolic coordinates
                  IcoE(ix,iy,iz)=IcoE(ix,iy,iz)
     $                 +f1*f2*IcoT(i1,i2,ix,iy,iz)*uu(i1)*uu(i2)
                  if(ish2.ge.1)
     $                 write (*,'(1pg13.6," ",$)') IcoT(i1,i2,ix,iy,iz)
                enddo
               if(ish2.ge.1) write (*,'(" |  ",1pg13.6)')
     $               IcoC(1,i1,ix,iy,iz)/max(0.00001,unorm2(1))
              enddo
              if(ish2.ge.1)write (*,*) 
              do i=1,3
                IcoV(i,ix,iy,iz)=uu(i)/uu(4)
              enddo
            endif
          enddo
        enddo
      enddo


      return
      end

c----------------------------------------------------------------------
      subroutine IcoAddptl(ps,xo,taum,ifl1,ifl2,ifl3)
      dimension ps(4),xo(4),ifl(3),b(5),pp(4)
      common /Ico10/ntot,ish0,irs
      include 'nexus.inc'
      include 'nexus.incico'


      sigma=0.5                 ! width of gaussian smoothing kernel
      rnorm=(2.*pi)**(1.5)*sigma**3 ! its normalization

      if(xo(3).ge.xo(4))then
        eta=1e10
	if(ish.ge.1)then
          call utmsg('IcoAddptl: xo(3).ge.xo(4) -> reject&')
          write(ifch,*)'iptl:',irs
          write(ifch,*)'xo:',xo
          call utmsgf
	endif
        return
      elseif(xo(3).le.-xo(4))then
        eta=-1e10
	if(ish.ge.1)then
          call utmsg('IcoAddptl: xo(3).le.-xo(4) -> reject&')
          write(ifch,*)'iptl:',irs
          write(ifch,*)'xo:',xo
          call utmsgf
	endif
        return
      else
        eta= 0.5d0*log((xo(4)+xo(3))/(xo(4)-xo(3)))
      endif
      if(ish0.gt.0)then
c        if(irs.ge.1.and.irs.le.matarg+maproj)
c     $       print *,"spectator",irs," at eta=",eta
c        if(irs.gt.matarg+maproj) print *,"remnamt",irs," at eta=",eta
      endif
      ifl(1)=ifl1
      ifl(2)=ifl2
      ifl(3)=ifl3
c     string ps(1..4) segment is calculated, 
c     now do the contribution to grid-points
      do iz=1,nzIco
        zz=zminIco +(float(iz)-0.5)*(zmaxIco-zminIco )/nzIco
c.............boost ps() into co-moving frame with rapidity=zz
c       write (*,222) "p1:",eta,pp
        pp(1)=ps(1)
        pp(2)=ps(2)
        pp(3)=ps(3)
        pp(4)=ps(4)
        b(1)=0.
        b(2)=0.
        b(3)=sinh(-zz)
        b(4)=cosh(zz)
        b(5)=1.0
        call utlobo(-1,b(1),b(2),b(3),b(4),b(5)
     $       ,pp(1),pp(2),pp(3),pp(4))
        do ix=1,nxIco
          xx=xminIco+(float(ix)-0.5)*(xmaxIco-xminIco)/nxIco
          do iy=1,nyIco
            yy=yminIco+(float(iy)-0.5)*(ymaxIco-yminIco)/nyIco
            d2=(xo(1)-xx)**2+(xo(2)-yy)**2
     $           +( taum*( eta - zz ))**2
            if(d2.gt.10.*sigma**2)then
              w=0.
            else
              w=exp(-d2/2./sigma**2)/rnorm
              if(pp(4).gt.0.)then
c.....................energy-momentum Tensor 
                do i1=1,4
                  do i2=1,4
                    IcoT(i1,i2,ix,iy,iz)=IcoT(i1,i2,ix,iy,iz)+
     $                   w*pp(i1)*pp(i2)/pp(4)
                  enddo
                enddo
c.....................velocity field of particles
                do i=1,3
                  if(ifl(i).ne.0)then
                    do i1=1,4
                      iafl=abs(ifl(i))
                      f=1.0*sign(1.0,float(ifl(i)))
                      IcoC(iafl,i1,ix,iy,iz)=IcoC(iafl,i1,ix,iy,iz)+
     $                     f*w*pp(i1)/pp(4)
                    enddo
                  endif
                enddo
              endif
            endif
          enddo
        enddo
      enddo
      
      end

c----------------------------------------------------------------------
      subroutine IcoAdddro(ps,xo,taum,nqu,nqd,nqs)
      dimension ps(4),xo(4),ifl(3),b(5),pp(4)
      common /Ico10/ntot,ish0,irs
      include 'nexus.inc'
      include 'nexus.incico'


      sigma=0.5                 ! width of gaussian smoothing kernel
      rnorm=(2.*pi)**(1.5)*sigma**3 ! its normalization

      if(xo(3).ge.xo(4))then
        eta=1e10
	if(ish.ge.1)then
          call utmsg('IcoAdddro: xo(3).ge.xo(4) -> reject&')
          write(ifch,*)'iptl:',irs
          write(ifch,*)'xo:',xo
          call utmsgf
	endif
        return
      elseif(xo(3).le.-xo(4))then
        eta=-1e10
	if(ish.ge.1)then
          call utmsg('IcoAdddro: xo(3).le.-xo(4) -> reject&')
          write(ifch,*)'iptl:',irs
          write(ifch,*)'xo:',xo
          call utmsgf
	endif
        return
      else
        eta= 0.5d0*log((xo(4)+xo(3))/(xo(4)-xo(3)))
      endif
      ifl(1)=nqu
      ifl(2)=nqd
      ifl(3)=nqs
c     string ps(1..4) segment is calculated, 
c     now do the contribution to grid-points
      do iz=1,nzIco
        zz=zminIco +(float(iz)-0.5)*(zmaxIco-zminIco )/nzIco
c.............boost ps() into co-moving frame with rapidity=zz
c       write (*,222) "p1:",eta,pp
        pp(1)=ps(1)
        pp(2)=ps(2)
        pp(3)=ps(3)
        pp(4)=ps(4)
        b(1)=0.
        b(2)=0.
        b(3)=sinh(-zz)
        b(4)=cosh(zz)
        b(5)=1.0
        call utlobo(-1,b(1),b(2),b(3),b(4),b(5)
     $       ,pp(1),pp(2),pp(3),pp(4))
        do ix=1,nxIco
          xx=xminIco+(float(ix)-0.5)*(xmaxIco-xminIco)/nxIco
          do iy=1,nyIco
            yy=yminIco+(float(iy)-0.5)*(ymaxIco-yminIco)/nyIco
            d2=(xo(1)-xx)**2+(xo(2)-yy)**2
     $           +( taum*( eta - zz ))**2
            if(d2.gt.10.*sigma**2)then
              w=0.
            else
              w=exp(-d2/2./sigma**2)/rnorm
              if(pp(4).gt.0.)then
c.....................energy-momentum Tensor 
                do i1=1,4
                  do i2=1,4
                    IcoT(i1,i2,ix,iy,iz)=IcoT(i1,i2,ix,iy,iz)+
     $                   w*pp(i1)*pp(i2)/pp(4)
                  enddo
                enddo
c.....................velocity field of particles
                do i=1,3
                  if(ifl(i).ne.0)then
                    do n=1,abs(ifl(i))
                      do i1=1,4
                        iafl=i
                        f=1.0*sign(1.0,float(ifl(i)))
                        IcoC(iafl,i1,ix,iy,iz)=IcoC(iafl,i1,ix,iy,iz)+
     $                                         f*w*pp(i1)/pp(4)
                      enddo
                    enddo
                  endif
                enddo
              endif
            endif
          enddo
        enddo
      enddo
      
      end



c----------------------------------------------------------------------
      subroutine xstr(nk1,nk2,sigma,tau,x,gp,gm,ixy)
c----------------------------------------------------------------------
c     calculates position if string as a function of sigma and tau
c     returns coordinate vector x(1..4) and velocity vector g(1..4)
c     string defined from nk1 to nk2 in pptl list
c----------------------------------------------------------------------
     
      include 'nexus.inc'
      logical pr
      dimension x(4),gp(4),gm(4)
      mmod(i)=mod(mod(i,nob)+nob,nob)

      data pr/.false./
      spt=sigma+tau
      smt=sigma-tau
c      if(sigma.gt.19.975) pr=.true.
      if(pr)print *,'sigma-region:',sigma,tau,smt,spt
      a=0.
      i=0
      nob=(nk2-nk1+1)*2
      ii=i+nk1 
      if(i.ge.nob/2) ii=nk1+(nob-1)-i
c.....positioning of index i 
      do while( smt-a.gt.pptl(4,ii) .or. smt-a.lt.0. )
        if(smt-a.lt.0.)then
          i=mmod(i-1)
          ii=i+nk1 
          if(i.ge.nob/2) ii=nk1+(nob-1)-i
          a=a-pptl(4,ii)
          if(pr)print *,'skip -1:',i,ii,nob,a,smt,pptl(4,ii)
        else
          a=a+pptl(4,ii)
          i=mmod(i+1)
          ii=i+nk1 
          if(i.ge.nob/2) ii=nk1+(nob-1)-i
          if(pr)print *,'skip +1:',i,ii,nob,a,smt
        endif
      enddo
c.....smt,smp are in one band ?
      if(spt-a.lt.pptl(4,ii))then !   on band-case
        if(pr)print *,'one:',i,(spt-smt),sigma,tau
        i1=ii
        i2=ii
        do k=1,4
          x(k)=pptl(k,ii)*((spt-smt))/pptl(4,ii)/2
          gp(k)=pptl(k,ii)/pptl(4,ii)
          gm(k)=0.
        enddo
      else
c.....  loop to band of spt
        if(pr)print *,'first:',i,(pptl(4,ii)-(smt-a))/pptl(4,ii)
        i1=ii
        do k=1,4
          x(k)=pptl(k,ii)*(pptl(4,ii)-(smt-a))/pptl(4,ii)/2
          gp(k)= 0.5*pptl(k,ii)/pptl(4,ii)
          gm(k)=-0.5*pptl(k,ii)/pptl(4,ii)
        enddo
        a=a+pptl(4,ii)
        i=mmod(i+1)
        ii=i+nk1
        if(i.ge.nob/2) ii=nk1+(nob-1)-i
        do while( spt-a.ge.pptl(4,ii) ) 
          if(pr)print *,'med:',i,a,1.0
          do k=1,4
            x(k)=x(k)+pptl(k,ii)/2
          enddo
          a=a+pptl(4,ii)
          i=mmod(i+1)
          ii=i+nk1 
          if(i.ge.nob/2) ii=nk1+(nob-1)-i
        enddo
        if(pr)print *,'last:',i,a,(spt-a)/pptl(4,ii)
        i2=ii
        do k=1,4
          x(k)=x(k)+pptl(k,ii)*(spt-a)/pptl(4,ii)/2
          gp(k)=gp(k)+0.5*pptl(k,ii)/pptl(4,ii)
          gm(k)=gm(k)+0.5*pptl(k,ii)/pptl(4,ii)
        enddo
      endif
      if(pr)print *,'x:',sigma,tau,x
      if(pr)write (*,'("gap:",12(g12.6,1x))') gp
      if(pr)write (*,'("gam:",12(g12.6,1x))') gm
      ixy=i1+nob*i2
      end
      
c----------------------------------------------------------------------
      subroutine xdens2()
c----------------------------------------------------------------------
c
c     density of Pomerons
c
      include 'nexus.inc'
      include 'nexus.incico'
      dimension rho(200,200) 
      character*90 filename 
c      save xy

c      nxico=50             ! nexus.incico ????
c      nyico=50

      fac=1
      xmin=-10 * fac
      xmax= 10 * fac
      ymin=-10 * fac
      ymax= 10 * fac

      do ix=1,nxico
        do iy=1,nyico
          rho(ix,iy)=0.
        enddo
      enddo

      sigma=0.5
      rnorm=((2.*pi)**(0.5)*sigma)**2.0
      do  i=1,nptl
        if ( mod(istptl(i)/10,10).ne.3) goto 54
        print *,i,istptl(i),xorptl(1,i),xorptl(2,i),xorptl(3,i)
        x=xorptl(1,i)
        y=xorptl(2,i)
        do ix=1,nxico
          xx=xmin+(float(ix)-0.5)*(xmax-xmin)/nxico
          do iy=1,nyico
            yy=ymin+(float(iy)-0.5)*(ymax-ymin)/nyico
            d2=(x-xx)**2+(y-yy)**2
            if(d2.gt.4.*sigma)then
              w=0.
            else
              w=exp(-d2/2./sigma**2)/rnorm
            endif
            rho(ix,iy) = rho(ix,iy) + w 
          enddo
        enddo
 54   enddo

      if(nrevt+1.eq.nevent)then
        if(index(fnhi(1:nfnhi),".histo").ne.0) then 
          filename=fnhi(1:index(fnhi(1:nfnhi),".histo")-1)//".pom"
        else
          filename=fnhi(1:nfnhi)//".pom"
        endif
        open(98,file=filename) 
        sum=0.
        iy=0
        do ix=1,nxico
          xx=xmin+(float(ix)-0.5)*(xmax-xmin)/nxico
          do iy=1,nyico
            yy=ymin+(float(iy)-0.5)*(ymax-ymin)/nyico          
            write (98,*) xx,yy,rho(ix,iy)
          enddo
          write (98,*)
        enddo
        close (98)
        print *,'sum pom=',sum
      endif
      end

c----------------------------------------------------------------------
      subroutine xdens2b()
c----------------------------------------------------------------------
c     
c     density of nucleons
c
      include 'nexus.inc'
      include 'nexus.incico'
      dimension rho(2,200,200) 
      character*90 filename 
c       save xy

c      nxico=25              !in nexus.incico (difference with xdens2)
c      nyico=25

      fac=1
      xmin=-10 * fac
      xmax= 10 * fac
      ymin=-10 * fac
      ymax= 10 * fac

      do ix=1,nxico
        do iy=1,nyico
          rho(1,ix,iy)=0.
          rho(2,ix,iy)=0.
        enddo
      enddo

      sigma=0.8
      rnorm=((2.*pi)**(0.5)*sigma)**2.0
      do  i=1,matarg+maproj
        in=1
        if(pptl(3,i).lt.0)in=2
        print *,i,in,istptl(i),xorptl(1,i),xorptl(2,i),xorptl(3,i)
        x=xorptl(1,i)
        y=xorptl(2,i)
        do ix=1,nxico
          xx=xmin+(float(ix)-0.5)*(xmax-xmin)/nxico
          do iy=1,nyico
            yy=ymin+(float(iy)-0.5)*(ymax-ymin)/nyico
            d2=(x-xx)**2+(y-yy)**2
            if(d2.gt.4.*sigma)then
              w=0.
            else
              w=exp(-d2/2./sigma**2)/rnorm
            endif
            rho(in,ix,iy) = rho(in,ix,iy) + w 
          enddo
        enddo
      enddo

      if(nrevt+1.eq.nevent)then
        if(index(fnhi(1:nfnhi),".histo").ne.0) then 
          filename=fnhi(1:index(fnhi(1:nfnhi),".histo")-1)//".nuc"
        else
          filename=fnhi(1:nfnhi)//".nuc"
        endif
        open(98,file=filename) 
        sum=0.
        iy=0
        do ix=1,nxico
          xx=xmin+(float(ix)-0.5)*(xmax-xmin)/nxico
          do iy=1,nyico
            yy=ymin+(float(iy)-0.5)*(ymax-ymin)/nyico          
            write (98,*) xx,yy,rho(1,ix,iy),rho(2,ix,iy)
          enddo
          write (98,*)
        enddo
        close (98)
        print *,'sum nuc=',sum
      endif
      end
