/* $Id: TCorsikaReader.cc,v 1.1.1.1 2005/08/09 11:21:28 rulrich Exp $   */

#include <crsIO/TLongitudinal.h>
using namespace crsIO;

#include <crs/TLongitudinal.h>


// -----------------
ClassImp (TLongitudinal)


TLongitudinal::TLongitudinal (const crs::TLongitudinal &right) {

  // CONVERT here ------------------
  Depth = right.GetSlantDepth ();
    
  nGammas = right.GetNGammas ();
  nElectrons = right.GetNElectrons ();
  nPositrons = right.GetNPositrons ();
  nMuons = right.GetNMuons ();
  nAntiMuons = right.GetNAntiMuons ();
  nHadrons = right.GetNHadrons ();
  nNuclei = right.GetNNuclei ();
  nCerenkov = right.GetNCerenkov ();

}


TLongitudinal::TLongitudinal () :
    
Depth (0),
  nGammas (0),
  nElectrons (0),
  nPositrons (0),
  nMuons (0),
  nAntiMuons (0),
  nHadrons (0),
  nNuclei (0),
  nCerenkov (0) {
}

